package uk.gov.dwp.maze;


public class Position {

    private int x;
    private int y;

    public Position(int x, int y){
        this.x = x;
        this.y = y;
    }

    public int getX() {
        return x;
    }

    public int getY() {
        return y;
    }

    public Position getNextForwardPosition(Direction currentDirection){
        Position nextPos;
        if(currentDirection == Direction.EAST){
            nextPos = new Position(x+1,y);
        } else if (currentDirection == Direction.WEST){
            nextPos = new Position(x-1,y);
        } else if (currentDirection == Direction.NORTH){
            nextPos = new Position(x,y-1);
        } else{
            nextPos = new Position(x,y+1);
        }
        return nextPos;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Position position = (Position) o;
        if (x != position.x) return false;
        if (y != position.y) return false;

        return true;
    }

    @Override
    public int hashCode() {
        return 31 * x + y;
    }

    @Override
    public String toString(){
        return "x="+x+"|y="+y;
    }


}

